diff --git a/gdb/ada-lang.c b/gdb/ada-lang.c
index 6956909..bf39f6b 100644
--- a/gdb/ada-lang.c
+++ b/gdb/ada-lang.c
@@ -19,7 +19,6 @@
 
 
 #include "defs.h"
-#include <stdio.h>
 #include <string.h>
 #include <ctype.h>
 #include <stdarg.h>
diff --git a/gdb/common/buffer.c b/gdb/common/buffer.c
index 4d9edb8..a50c890 100644
--- a/gdb/common/buffer.c
+++ b/gdb/common/buffer.c
@@ -29,7 +29,6 @@
 
 #include <stdlib.h>
 #include <string.h>
-#include <stdio.h>
 #include <stdint.h>
 
 void
diff --git a/gdb/common/common-defs.h b/gdb/common/common-defs.h
index 9e397d9..0fc7af5 100644
--- a/gdb/common/common-defs.h
+++ b/gdb/common/common-defs.h
@@ -27,4 +27,6 @@
 #include "build-gnulib/config.h"
 #endif
 
+#include <stdio.h>
+
 #endif /* COMMON_DEFS_H */
diff --git a/gdb/common/common-utils.c b/gdb/common/common-utils.c
index 29fe2c5..41ef289 100644
--- a/gdb/common/common-utils.c
+++ b/gdb/common/common-utils.c
@@ -27,7 +27,6 @@
 #include <string.h>
 
 #include <stdlib.h>
-#include <stdio.h>
 
 /* The xmalloc() (libiberty.h) family of memory management routines.
 
diff --git a/gdb/cp-name-parser.y b/gdb/cp-name-parser.y
index 7d9d925..6a9d13d 100644
--- a/gdb/cp-name-parser.y
+++ b/gdb/cp-name-parser.y
@@ -31,7 +31,6 @@
 
 #include "defs.h"
 
-#include <stdio.h>
 #include <stdlib.h>
 #include <unistd.h>
 #include <string.h>
diff --git a/gdb/defs.h b/gdb/defs.h
index 422c4e8..49e45b8 100644
--- a/gdb/defs.h
+++ b/gdb/defs.h
@@ -28,7 +28,6 @@
 #include "common-defs.h"
 
 #include <sys/types.h>
-#include <stdio.h>
 #include <errno.h>		/* System call error return status.  */
 #include <limits.h>
 #include <stdint.h>
diff --git a/gdb/gdbserver/linux-low.c b/gdb/gdbserver/linux-low.c
index 521d9a2..0b9353e 100644
--- a/gdb/gdbserver/linux-low.c
+++ b/gdb/gdbserver/linux-low.c
@@ -24,7 +24,6 @@
 #include "nat/linux-nat.h"
 #include "nat/linux-waitpid.h"
 #include "gdb_wait.h"
-#include <stdio.h>
 #include <sys/ptrace.h>
 #include "nat/linux-ptrace.h"
 #include "nat/linux-procfs.h"
diff --git a/gdb/gdbserver/remote-utils.c b/gdb/gdbserver/remote-utils.c
index 4fcafa0..96d6038 100644
--- a/gdb/gdbserver/remote-utils.c
+++ b/gdb/gdbserver/remote-utils.c
@@ -24,7 +24,6 @@
 #include "dll.h"
 #include "rsp-low.h"
 
-#include <stdio.h>
 #include <string.h>
 #if HAVE_SYS_IOCTL_H
 #include <sys/ioctl.h>
diff --git a/gdb/gdbserver/server.h b/gdb/gdbserver/server.h
index ef66a32..743a368 100644
--- a/gdb/gdbserver/server.h
+++ b/gdb/gdbserver/server.h
@@ -30,7 +30,6 @@
 #include "version.h"
 
 #include <stdarg.h>
-#include <stdio.h>
 #include <stdlib.h>
 #ifdef HAVE_ERRNO_H
 #include <errno.h>
diff --git a/gdb/gdbserver/spu-low.c b/gdb/gdbserver/spu-low.c
index 9bb0c40..67ff147 100644
--- a/gdb/gdbserver/spu-low.c
+++ b/gdb/gdbserver/spu-low.c
@@ -21,7 +21,6 @@
 #include "server.h"
 
 #include "gdb_wait.h"
-#include <stdio.h>
 #include <sys/ptrace.h>
 #include <fcntl.h>
 #include <string.h>
diff --git a/gdb/gdbserver/utils.c b/gdb/gdbserver/utils.c
index 2d0b331..b87bcc9 100644
--- a/gdb/gdbserver/utils.c
+++ b/gdb/gdbserver/utils.c
@@ -17,7 +17,6 @@
    along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 #include "server.h"
-#include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
 #if HAVE_ERRNO_H
diff --git a/gdb/gdbserver/wincecompat.c b/gdb/gdbserver/wincecompat.c
index 68f6aa9..7d45b30 100644
--- a/gdb/gdbserver/wincecompat.c
+++ b/gdb/gdbserver/wincecompat.c
@@ -18,7 +18,6 @@
 
 #include "server.h"
 
-#include <stdio.h>
 #include <windows.h>
 
 void
diff --git a/gdb/gnu-nat.c b/gdb/gnu-nat.c
index 176f4a1..a2de2f1 100644
--- a/gdb/gnu-nat.c
+++ b/gdb/gnu-nat.c
@@ -27,7 +27,6 @@
 #include <limits.h>
 #include <setjmp.h>
 #include <signal.h>
-#include <stdio.h>
 #include <string.h>
 #include <sys/ptrace.h>
 
diff --git a/gdb/go32-nat.c b/gdb/go32-nat.c
index b2570e8..42133d6 100644
--- a/gdb/go32-nat.c
+++ b/gdb/go32-nat.c
@@ -105,7 +105,6 @@
 #include "cli/cli-utils.h"
 #include "inf-child.h"
 
-#include <stdio.h>		/* might be required for __DJGPP_MINOR__ */
 #include <stdlib.h>
 #include <ctype.h>
 #include <errno.h>
diff --git a/gdb/i386gnu-nat.c b/gdb/i386gnu-nat.c
index d0a610b..23a70b3 100644
--- a/gdb/i386gnu-nat.c
+++ b/gdb/i386gnu-nat.c
@@ -24,7 +24,6 @@
 
 #include "gdb_assert.h"
 #include <errno.h>
-#include <stdio.h>
 #include <string.h>
 
 #include <mach.h>
diff --git a/gdb/proc-api.c b/gdb/proc-api.c
index 2ae7b84..c4aecc4 100644
--- a/gdb/proc-api.c
+++ b/gdb/proc-api.c
@@ -34,7 +34,6 @@
 #define _STRUCTURED_PROC 1
 #endif
 
-#include <stdio.h>
 #include <sys/types.h>
 #include <sys/procfs.h>
 #ifdef HAVE_SYS_PROC_H
diff --git a/gdb/proc-events.c b/gdb/proc-events.c
index 68f004f..bc494c3 100644
--- a/gdb/proc-events.c
+++ b/gdb/proc-events.c
@@ -34,7 +34,6 @@
 #define _STRUCTURED_PROC 1
 #endif
 
-#include <stdio.h>
 #include <sys/types.h>
 #include <sys/procfs.h>
 #ifdef HAVE_SYS_SYSCALL_H
diff --git a/gdb/proc-flags.c b/gdb/proc-flags.c
index 7c37e35..31af26d 100644
--- a/gdb/proc-flags.c
+++ b/gdb/proc-flags.c
@@ -31,7 +31,6 @@
 #define _STRUCTURED_PROC 1
 #endif
 
-#include <stdio.h>
 #include <sys/types.h>
 #include <sys/procfs.h>
 
diff --git a/gdb/proc-why.c b/gdb/proc-why.c
index 72c28e1..c053c9e 100644
--- a/gdb/proc-why.c
+++ b/gdb/proc-why.c
@@ -24,7 +24,6 @@
 #define _STRUCTURED_PROC 1
 #endif
 
-#include <stdio.h>
 #include <sys/types.h>
 #include <sys/procfs.h>
 
diff --git a/gdb/python/python-internal.h b/gdb/python/python-internal.h
index b7298d9..6e7e600 100644
--- a/gdb/python/python-internal.h
+++ b/gdb/python/python-internal.h
@@ -62,8 +62,6 @@
 #define CPYCHECKER_NEGATIVE_RESULT_SETS_EXCEPTION
 #endif
 
-#include <stdio.h>
-
 /* Python 2.4 doesn't include stdint.h soon enough to get {u,}intptr_t
    needed by pyport.h.  */
 #include <stdint.h>
diff --git a/gdb/target-memory.c b/gdb/target-memory.c
index 1c6cd40..583d337 100644
--- a/gdb/target-memory.c
+++ b/gdb/target-memory.c
@@ -25,7 +25,6 @@
 
 #include "gdb_assert.h"
 
-#include <stdio.h>
 #include <sys/time.h>
 
 static int
diff --git a/gdb/tui/tui-io.c b/gdb/tui/tui-io.c
index 75eb4b8..a890678 100644
--- a/gdb/tui/tui-io.c
+++ b/gdb/tui/tui-io.c
@@ -36,7 +36,6 @@
 #include "cli-out.h"
 #include <fcntl.h>
 #include <signal.h>
-#include <stdio.h>
 #include "filestuff.h"
 
 #include "gdb_curses.h"
diff --git a/gdb/tui/tui.c b/gdb/tui/tui.c
index c30b76c..413ec20 100644
--- a/gdb/tui/tui.c
+++ b/gdb/tui/tui.c
@@ -38,7 +38,6 @@
 #include "symtab.h"
 #include "source.h"
 
-#include <stdio.h>
 #include <stdlib.h>
 #include <ctype.h>
 #include <signal.h>